package edu.thi.phga.aparapi_test;

import com.aparapi.device.OpenCLDevice;
import javafx.application.Application;

public class App {
  public static int choice;
  public static OpenCLDevice device;
  public static int multiParam;
  public static String selectedImage;
  private static void printHeader(final String txt) {
    final String spacer =
      "######################################################################";
    System.out.printf("%s\n%s\n", spacer, txt);
  }
  public static void main( String[] args ) {
    // System.out.println("Running the OpenCL Tasks");
    if (args.length == 0) {
      App.choice = 0;
    } else {
      App.choice = Integer.parseInt(args[0]) - 1;
    }
    App.device = Devices.selectDevice();
    App.device.setMaxWorkGroupSize(256); // used for 2D, 3D derive
    App.device.setMaxWorkItemSize(0, 256); // used for 1D
    App.device.setMaxWorkItemSize(1, 16); // used for 2D

    int target = 0;
    if (args.length > 1) {
      target = Integer.parseInt(args[1]);
    }
    App.multiParam = 25;
    App.selectedImage = "lena.bmp";
    if (args.length > 2) {
      if (target >= 60 && target < 70)
        App.selectedImage = args[2];
      else {
        App.multiParam = Integer.parseInt(args[2]);
      }
    }
    App.selectedImage = "file:./pictures/" + App.selectedImage;
    final int[] b;
    switch (target) {
      case 0:
        OpenCLGetMemoryInfo.getInfo();
        OpenCLSizeTest.start(8);
        break;
        // PRIMES
      case 10:
        printHeader("FindPrimes (Seriell, Parallel, OpenCL)");
        // Ab 1 << 14 stimmt es nicht mehr
        // final int[] a = {8, 5, 6, 2, 3, 7, 1, 4};
        // CPU is faster than GPU...
        FindPrimes.start();
        FindPrimesThreads.start();
        FindPrimesOpenCL.start();
        break;
        // REDUCE
      case 20:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce1.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce2.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce3.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce4.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce5.start(b);
        break;
      case 21:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce1.start(b);
        break;
      case 22:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce2.start(b);
        break;
      case 23:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce3.start(b);
        break;
      case 24:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce4.start(b);
        break;
      case 25:
        b = new int[1 << App.multiParam];
        java.util.Arrays.fill(b, 1);
        OpenCLReduce5.start(b);
        break;
        // PREFIX
      case 30:
        b = new int[1 << App.multiParam];
        // Up to 1 << 27
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix1.start(b);
        // Up to 1 << 28
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix2.start(b);
        break;
      case 31:
        b = new int[1 << App.multiParam];
        // Up to 1 << 27
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix1.start(b);
        break;
      case 32:
        b = new int[1 << App.multiParam];
        // Up to 1 << 28
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix2.start(b);
        break;
      case 40:
        // multiParam defines smoothing
        System.out.println("Spawning window Filter");
        Application.launch(Rauschfilter.class);
        break;
      case 50:
        // multiParam defines ZOOM
        System.out.println("Spawning window Mandelbrot");
        Application.launch(Mandelbrot.class);
        break;
      case 60:
        System.out.println("Spawning window RGBHistogramm");
        Application.launch(RGBHistogramm.class);
        break;
      case 70:
        System.out.println("Radix Sort");
        RadixSort.start();
      case 80:
        System.out.println("Matrix Mult");
        MatrixMult.start();
    }
  }
}
