package edu.thi.phga.aparapi_test;

import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class FindPrimesThreads {
  private static final int N = 10_000_000;
  private static final int P = Runtime.getRuntime().availableProcessors();
  private static int START = 123_456_789;
  private static boolean[] istPrime = new boolean[N];

  public static void start() {
    long t1 = System.nanoTime();
    primeTest();
    long t2 = System.nanoTime();

    int a = 0;
    for (var b : istPrime) {
      if (b) {
        a++;
      }
    }

    System.out.println("Threads(" + P + "): " + (t2 - t1) / 1000000 + " ms: " + a);

  }

  private static void primeTest() {
    // Taskliste anlegen
    List<Callable<Object>> tasks = IntStream
      .range(0, P)
      .mapToObj(Task::new)
      .map(Executors::callable)
      .collect(Collectors.toList());

    try {
      Executors.newCachedThreadPool().invokeAll(tasks);
    } catch (InterruptedException e) {

    }

  }

  private static class Task implements Runnable {
    private static final int SPANNE = N / P;
    private int index;

    Task(int index) {
      this.index = index;
    }

    @Override
    public void run() {
      int start = START + index * 2 * SPANNE;
      for (int z = start, i = 0; i < SPANNE; z += 2, i++) {
        int teiler = 3;

        while(z > teiler * teiler && z % teiler != 0){
          teiler += 2;
        }

        istPrime[index * SPANNE + i] = z % teiler != 0;
      }
    }
  }
}
