package edu.thi.phga.aparapi_test;

import java.util.Random;

import com.aparapi.Kernel;
import com.aparapi.Range;

public class MatrixMult {
  private static int n = App.multiParam;
  private static int[] a = new Random().ints(n * n, 1, 10).toArray();
  private static int[] b = new Random().ints(n * n, 1, 10).toArray();
  private static int[] c = new int[n * n];

  public static void start() {

    Range r = Range.create(App.device, n);
    MatMulKernel k = new MatMulKernel(a, b, c);
    k.execute(r);

    if (n < 10) {
      print();
    } else {
      System.out.println("Success: Choose n < 10 to print matrices");

    }
  }

  private static void print() {
    for (int i = 0; i < n; i++) {
      for (int x = 0; x < n; x++) {
        System.out.printf("%d ", a[i * n + x]);
      }

      if (i == n/2) {
        System.out.print(" * ");
      } else {
        System.out.print("   ");
      }

      for (int x = 0; x < n; x++) {
        System.out.printf("%d ", b[i * n + x]);
      }

      if (i == n/2) {
        System.out.print(" = ");
      } else {
        System.out.print("   ");
      }

      for (int x = 0; x < n; x++) {
        System.out.printf("%d ", c[i * n + x]);
      }
      System.out.println("");
    }
  }

  private static class MatMulKernel extends Kernel {
    private int[] a, b, c;
    MatMulKernel(int[] a, int[] b, int[] c) {
      this.a = a;
      this.b = b;
      this.c = c;
    }

    @Override public void run() {
      int i = getGlobalId(0);
      int size = getGlobalSize();

      for (int j = 0; j < size; j++) {
        for (int k = 0; k < size; k++) {
          c[i * size + j] += a[i * size + k] * b[k * size + j];
        }
      }

      // int n = getGlobalSize();
      // int i = getGlobalId();

      // for (int j = 0; j < n; j++) {
      //   for (int k = 0; k < n; k++) {
      //     c[i * n + j] += a[i *n + k] * b[k * n + j];
      //   }
      // }
    }
  }
}
