package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;
import com.aparapi.Range;

public class OpenCLReduce1 {
  public static void start(final int[] a) {
    int optimalSize = a.length / 2;
    int[] gs = new int[optimalSize];

    Kernel k = new Kernel() {
        @Override
        public void run() {
          int i = getGlobalId();
          int size = getGlobalSize();

          gs[i] = size;

          for (int s = 1; s <= size; s *= 2) {
            if (i % s == 0) {
              a[2 * i] += a[2 * i + s];
            }
          }
        }
      };
    k.execute(Range.create(optimalSize, optimalSize <= 256 ? optimalSize : 256));
    double ct = k.getConversionTime();
    double et = k.getExecutionTime() - ct;

      // if (a.length <= 64) {
      //   for (int x = 0; x < optimalSize; x++) {
      //     System.out.printf("GI: %d, GSize: %d\n", x, gs[x]);
      //   }
      // } else {
      //     System.out.printf("GI: %d, GSize: %d\n", 0, gs[0]);
      //     System.out.printf("GI: %d, GSize: %d\n", optimalSize - 1, gs[optimalSize - 1]);
      // }
      System.out.printf("R1 - WANT: %d, GOT: %d, TIME: %.2f ms\n", a.length, a[0], et);
  }
}
