package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;

public class RGBHistogrammKernel extends Kernel {
  private int[] pixel;
  private int[] r;
  private int[] g;
  private int[] b;

  public RGBHistogrammKernel(int[] pixel, int[] r, int[] g, int[] b) {
    this.pixel = pixel;
    this.r = r;
    this.g = g;
    this.b = b;
  }

  @Override
  public void run() {
    int x = getGlobalId(0);
    int y = getGlobalId(1);

    // int redM   = 0x00ff0000;
    // int greenM = 0x0000ff00;
    // int blueM  = 0x000000ff;

    int index = y * getGlobalSize(0) + x;

    // atomicAdd(r,(pixel[index] & redM) >> 16, 1);
    // atomicAdd(g,(pixel[index] & greenM) >> 8, 1);
    // atomicAdd(b, pixel[index] & blueM, 1);

    int cp = pixel[index];
    atomicAdd(r, (cp >> 16) & 0xff, 1);
    atomicAdd(g, (cp >> 8) & 0xff, 1);
    atomicAdd(b, cp & 0xff, 1);
  }
}
